package com.company.manytomany.entity;

import com.haulmont.chile.core.annotations.Composition;
import com.haulmont.chile.core.annotations.NamePattern;
import com.haulmont.cuba.core.entity.StandardEntity;
import com.haulmont.cuba.core.entity.annotation.OnDelete;
import com.haulmont.cuba.core.global.DeletePolicy;

import javax.persistence.*;
import java.util.List;

@NamePattern("%s|name")
@Table(name = "MANYTOMANY_UNIT")
@Entity(name = "manytomany_Unit")
public class Unit extends StandardEntity {
    @Column(name = "NAME")
    protected String name;

    @Composition
    @OnDelete(DeletePolicy.CASCADE)
    @OneToMany(mappedBy = "unit")
    protected List<Condition> conditions;

    @JoinTable(name = "MANYTOMANY_ACTIVITY_UNIT_LINK",
            joinColumns = @JoinColumn(name = "UNIT_ID"),
            inverseJoinColumns = @JoinColumn(name = "ACTIVITY_ID"))
    @ManyToMany(mappedBy = "")
    protected List<Activity> activities;

    public List<Activity> getActivities() {
        return activities;
    }

    public void setActivities(List<Activity> activities) {
        this.activities = activities;
    }

    public List<Condition> getConditions() { return conditions; }

    public void setConditions(List<Condition> conditions) { this.conditions = conditions; }

    public String getName() { return name; }

    public void setName(String name) { this.name = name; }
}