package com.company.manytomany.web.activity;

import com.company.manytomany.entity.Activity;
import com.company.manytomany.entity.Condition;
import com.company.manytomany.entity.Unit;
import com.company.manytomany.web.unit.UnitEdit;
import com.haulmont.cuba.core.entity.Entity;
import com.haulmont.cuba.core.global.Metadata;
import com.haulmont.cuba.gui.ScreenBuilders;
import com.haulmont.cuba.gui.components.Action;
import com.haulmont.cuba.gui.components.Table;
import com.haulmont.cuba.gui.model.CollectionPropertyContainer;
import com.haulmont.cuba.gui.model.DataContext;
import com.haulmont.cuba.gui.screen.*;

import javax.inject.Inject;
import java.util.Collection;
import java.util.List;
import java.util.UUID;

@UiController("manytomany_Activity.edit")
@UiDescriptor("activity-edit.xml")
@EditedEntityContainer("activityDc")
@LoadDataBeforeShow
public class ActivityEdit extends StandardEditor<Activity> {
    @Inject
    private Metadata metadata;

    @Inject
    private Table<Unit> unitsTable;

    @Inject
    private CollectionPropertyContainer<Condition> conditionsDc;

    @Subscribe("unitsTable.createCondition")
    private void onUnitsTableCreateCondition(Action.ActionPerformedEvent event) {
        final Condition condition = metadata.create(Condition.class);
        condition.setName(UUID.randomUUID().toString());
        condition.setUnit(unitsTable.getSingleSelected());
        conditionsDc.getMutableItems().add(condition);
    }

    @Inject
    private ScreenBuilders screenBuilders;

    @Inject
    private CollectionPropertyContainer<Unit> unitsDc;

    @Subscribe("unitsTable.createCustom")
    private void onUnitsTableCreateCustom(Action.ActionPerformedEvent event) {
        final Screen screen = screenBuilders.editor(unitsTable)
                .newEntity()
                .build();
        screen.show();
    }




    //Здесь мы можем видеть, что в preCommit прилетает Unit с заполенным Conditions
    @Subscribe(target = Target.DATA_CONTEXT)
    private void onPreCommit(DataContext.PreCommitEvent event) {
        final Collection<Entity> modifiedInstances = event.getModifiedInstances();
        modifiedInstances.forEach(entity -> {
            if (entity instanceof Activity){
                final Activity activity = (Activity) entity;
                final List<Unit> units = activity.getUnits();
                System.out.println(units);
                units.forEach(unit -> System.out.println(unit.getConditions()));
            }
        });
    }



}